/*
Copyright (c) 2004 Bart Upchurch

Permission is hereby granted, free of charge, to any person 
obtaining a copy of this software and associated documentation 
files (the "Software"), to deal in the Software without 
restriction, including without limitation the rights to use, 
copy, modify, merge, publish, distribute, sublicense, and/or 
sell copies of the Software, and to permit persons to whom 
the Software is furnished to do so, subject to the 
following conditions:

The above copyright notice and this permission notice shall 
be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
#include <Application.h>
#include <Window.h>
#include <View.h>
#include <String.h>

#include "MeasureDefs.h"
#include "MeasureApp.h"
#include "MeasureWindow.h"
#include "MeasureView.h"


//void MeasureWindow::WindowActivated(bool active) {
	//for some reason this is required to activate the View Activated function
	//Should this not be Automatic
	//if (active) {
	//	aView = FindView("measureView");
	//	aView->WindowActivated(true);
	//};
//}

void MeasureWindow::FrameMoved(BPoint origin) {
	
	//Redraw View each time the Window is moved
	aView = FindView("measureView");
	aView->Invalidate();

} 

void MeasureWindow::FrameResized(float width, float height) {
		
	BString windowTitle;
	
	//Replaced the C way witht the BeOS way of doing strings
	if (width < 200)
		//sprintf(windowTitle,"%d, %d", windowHeight,windowWidth);
		windowTitle << (int32)width << ", " << (int32)height;
	else
		//sprintf(windowTitle,"Height: %d, Width: %d", windowHeight,windowWidth);
		windowTitle << "Width: " << (int32)width << ", Height: " << (int32)height;
			
	SetTitle(windowTitle.String()); 
	
	//Redraw View each time the Window is Resized
	aView = FindView("measureView");
	aView->Invalidate();

}

bool MeasureWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

MeasureWindow::MeasureWindow(BRect frame)
			: BWindow(frame, "Measure", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE) {
	
	//Create a View
	BRect viewRect = Bounds();
	MeasureView *mView;
	
	mView = new MeasureView(viewRect,"measureView");
	AddChild(mView); 
	mView->MakeFocus();
	Show(); 
}